#include "piece.h"

// Q4
Piece::Piece() {
    int type=rand()%8;
    Color cols[8] = {RED, GREEN, BLUE, CYAN, MAGENTA, PURPLE, ORANGE, YELLOW};
    c = cols[type];
    x = (size-1)/2;
    y = (size-1)/2;
    for(int i=0; i<3; i++)
        for(int j=0; j<3; j++)
            blocs[i][j]=false;
    if(type==0) {
        blocs[1][1]=true;
        return;
    }
    if(type==1) {
        for(int i=0; i<3; i++)
            for(int j=0; j<3; j++)
                blocs[i][j]=true;
        return;
    }
    if(type==2) {
        for(int i=0; i<3; i++)
            blocs[i][1]=true;
        return;
    }
    if(type==3) {
        for(int i=0; i<3; i++)
            blocs[1][i]=true;
        return;
    }
    // En forme de L:
    type -= 4;
    int x = 2*(type%2);
    int y = 2*(type/2);
    for(int i=0; i<3; i++) {
        blocs[x][i]=true;
        blocs[i][y]=true;
    }
}

// Q5
bool Piece::bloc(int i, int j) const {
    assert(-1<=i && i<=1 && -1<=j && j<=1);
    return blocs[i+1][j+1];
}

// Q6
void Piece::dessine() const {
    for(int i=-1; i<=1; i++)
        for(int j=-1; j<=1; j++)
            if(bloc(i,j))
                fillRect(marge+(x+i)*z+1, margeScore+(y+j)*z+1, z-1, z-1, c);
}

// Q9
Plateau::Plateau(int w0, int h0) {
    w = w0;
    h = h0;
    cases = new Color[w*h];
    for(int i=0; i<w*h; i++)
        cases[i] = WHITE;
}
Plateau::~Plateau() {
    delete [] cases;
}

// Q10
void Plateau::dessine() const {
    for(int y=0; y<h; y++)
        for(int x=0; x<w; x++)
            fillRect(marge+x*z+1, margeScore+y*z+1, z-1, z-1, cases[y*w+x]);
}

// Q11
bool Plateau::contient(const Piece& p) const {
    for(int i=-1; i<=1; i++)
        for(int j=-1; j<=1; j++)
            if(p.bloc(i,j) && (p.x+i<0 || p.x+i>=w || p.y+j<0 || p.y+j>=h))
                return false;
    return true;
}

// Q12
bool Plateau::verifie(const Piece& p) const {
    if(! contient(p))
        return false;
    for(int i=-1; i<=1; i++)
        for(int j=-1; j<=1; j++)
            if(p.bloc(i,j) && cases[(p.y+j)*w+(p.x+i)]!=WHITE)
                return false;
    return true;
}

// Q13
int Plateau::positions(const Piece& p0) const {
    int i=0;
    Piece p = p0;
    for(p.y=0; p.y<h; p.y++)
        for(p.x=0; p.x<w; p.x++)
            if(verifie(p))
                ++i;
    return i;
}

// Q 14
void Plateau::absorbe(const Piece& p) {
    assert(verifie(p));
    for(int i=-1; i<=1; i++)
        for(int j=-1; j<=1; j++)
            if(p.bloc(i,j))
                cases[(p.y+j)*w+(p.x+i)] = p.couleur();
}

// Q16
int Plateau::detruis() {
    // Comptage
    int* lignes = new int[h];
    int* colonnes = new int[w];
    int nlignes=0, ncolonnes=0;
    for(int y=0; y<h; y++) {
        int x;
        for(x=0; x<w; x++)
            if(cases[y*w+x] == WHITE)
                break;
        if(x==w)
            lignes[nlignes++] = y;
    }
    for(int x=0; x<w; x++) {
        int y;
        for(y=0; y<h; y++)
            if(cases[y*w+x] == WHITE)
                break;
        if(y==h)
            colonnes[ncolonnes++] = x;
    }
    // Destruction
    for(int i=0; i<nlignes; i++) {
        int y = lignes[i];
        for(int x=0; x<w; x++)
            cases[y*w+x] = WHITE;
    }
    for(int i=0; i<ncolonnes; i++) {
        int x = colonnes[i];
        for(int y=0; y<h; y++)
            cases[y*w+x] = WHITE;
    }
    delete [] lignes;
    delete [] colonnes;
    return w*nlignes + h*ncolonnes - nlignes*ncolonnes;
}
